﻿var JiraRestHelper = (function () {
  var helper = function () {};

  helper.urls = {
    UgyfelSzolgalatPopUp: null,
    BejelentesPopUp: null,
    KommunikaciosPopUp: null,

    CreateCommentToBejegyzes: null,
    CreateBejelentes: null,
    CreateDbVisszaallitas: null,
    CreateUjUrlIgenyles: null,
    CreateKonferenciaJelentkezes: null
  };
  helper.popUpTitles = {
    UgyfelSzolgalat: { title: '', text: '' },
    Bejelentes: { title: '', text: '' },
    Kommunikacios: { title: '', text: '' }
  };

  helper.createCommentToBejegyzes = function (
    id,
    leiras,
    csatolmanyArray,
    successCallBack,
    errorCallBack
  ) {
    AjaxHelper.AsyncPost(
      helper.urls.CreateCommentToBejegyzes,
      { Id: id, Comment: leiras, CsatolmanyArray: csatolmanyArray },
      successCallBack,
      errorCallBack
    );
  };
  helper.createBejelentes = function (
    cim,
    leiras,
    requestTypeId,
    csatolmanyArray,
    userAndBrowserInformation,
    errorCallBack
  ) {
    AjaxHelper.DoAsyncValidationPost(
      helper.urls.CreateBejelentes,
      'UgyfelszolgValidation',
      {
        Cim: cim,
        Leiras: leiras,
        RequestTypeId: requestTypeId,
        CsatolmanyArray: csatolmanyArray,
        UserAndBrowserInformation: userAndBrowserInformation
      },
      function () {
        successCallBack('BejelentesWindow');
      },
      errorCallBack
    );
  };
  helper.createDbVisszaallitas = function (
    date,
    requestTypeId,
    userAndBrowserInformation
  ) {
    AjaxHelper.DoAsyncValidationPost(
      helper.urls.CreateDbVisszaallitas,
      'UgyfelszolgValidation',
      {
        Datum: date,
        RequestTypeId: requestTypeId,
        UserAndBrowserInformation: userAndBrowserInformation
      },
      function () {
        successCallBack('BejelentesWindow');
      }
    );
  };
  helper.createUjUrlIgenyles = function (
    ujUrlName,
    requestTypeId,
    userAndBrowserInformation
  ) {
    AjaxHelper.DoAsyncValidationPost(
      helper.urls.CreateUjUrlIgenyles,
      'UgyfelszolgValidation',
      {
        UjUrlName: ujUrlName,
        RequestTypeId: requestTypeId,
        UserAndBrowserInformation: userAndBrowserInformation
      },
      function () {
        successCallBack('BejelentesWindow');
      }
    );
  };
  helper.createKonferenciaJelentkezes = function (
    jelentkezoSzemelyekSzama,
    jelentkezoSzemelyekListaja,
    egyebUzenet,
    requestTypeId,
    userAndBrowserInformation
  ) {
    AjaxHelper.DoAsyncValidationPost(
      helper.urls.CreateKonferenciaJelentkezes,
      'UgyfelszolgValidation',
      {
        JelentkezoSzemelyekSzama: jelentkezoSzemelyekSzama,
        JelentkezoSzemelyekListaja: jelentkezoSzemelyekListaja,
        EgyebUzenet: egyebUzenet,
        RequestTypeId: requestTypeId,
        UserAndBrowserInformation: userAndBrowserInformation
      },
      function () {
        successCallBack('BejelentesWindow');
      }
    );
  };
  helper.popUpUgyfelSzolgalatWindow = function () {
    AjaxHelper.DoPost(helper.urls.UgyfelSzolgalatPopUp, null, function (data) {
      openPopUp(helper.popUpTitles.UgyfelSzolgalat, data);
    });
  };
  helper.popUpBejelentesWindow = function (id, key) {
    AjaxHelper.DoPost(
      helper.urls.BejelentesPopUp,
      { typeId: id, typeKey: key },
      function (data) {
        openPopUp(helper.popUpTitles.Bejelentes, data);
      }
    );
  };
  helper.popUpKommunikaciosWindow = function (rowData) {
    AjaxHelper.DoPost(
      helper.urls.KommunikaciosPopUp,
      { id: rowData.ID },
      function (data) {
        openPopUp(helper.popUpTitles.Kommunikacios, data);
      }
    );
  };

  function openPopUp(info, data) {
    var config = KretaWindowHelper.getWindowConfigContainer();
    config.title = info.text;
    config.content = data;
    if (info.text === 'UgyfelSzolgalat') {
      config.width = '90%';
      config.height = '90%';
    } else {
      config.width = '85%';
      config.height = '85%';
    }

    var modal = KretaWindowHelper.createWindow(info.title, config);
    KretaWindowHelper.openWindow(modal, true);
  }

  function successCallBack(viewName) {
    KretaWindowHelper.destroyWindow(viewName);
    KretaGridHelper.refreshGrid('UgyfelszolgalatGrid');
  }

  helper.successCallBack = function (viewName) {
    successCallBack(viewName);
  };

  var descriptionMaxLength;
  helper.ValidateDescriptionLength = function (descriptionMaxLengthParameter) {
    Number.isInteger =
      Number.isInteger ||
      function (value) {
        return (
          typeof value === 'number' &&
          isFinite(value) &&
          Math.floor(value) === value
        );
      };
    if (Number.isInteger(descriptionMaxLengthParameter))
      descriptionMaxLength = descriptionMaxLengthParameter;
    var descriptionText = $('.validateDescriptionLength');
    var labelText = $('#validateDescriptionLengthLabel');

    if (descriptionText.val().length > descriptionMaxLength) {
      labelText.addClass('validateErrorLabelColor');
      descriptionText.val(
        descriptionText.val().substring(0, descriptionMaxLength)
      );
    } else {
      labelText.removeClass('validateErrorLabelColor');
    }

    labelText.text(
      'Karakter: ' + descriptionMaxLength + '/' + descriptionText.val().length
    );
  };
  return helper;
})();
