﻿var KretaImportGridHelper = (function () {
  var kretaImportGridHelper = function () {};

  kretaImportGridHelper.initializeGrid = function (
    gridId,
    columns,
    dataSource,
    rowTemplateId
  ) {
    var defaultImportPreviewPopupHeight = 768;
    var gridHeight = 675;
    var gridContentMaxHeight = 586;

    var currentImportPreviewPopupHeight = $('#ImportPreviewPopup')
      .parent()
      .height();
    if (defaultImportPreviewPopupHeight !== currentImportPreviewPopupHeight) {
      var difference =
        defaultImportPreviewPopupHeight - currentImportPreviewPopupHeight;
      gridHeight -= difference;
      gridContentMaxHeight -= difference;
    }

    $('#' + gridId).kendoGrid({
      columns: columns,
      dataSource: dataSource,
      sortable: true,
      pageable: {
        alwaysVisible: false,
        pageSize: 15,
        buttonCount: 5,
        messages: {
          display: '{0} - {1} / {2}',
          empty: Globalization.NincsAdat,
          first: Globalization.ElsoOldal,
          last: Globalization.UtolsoOldal,
          next: Globalization.KovetkezoOldal,
          previous: Globalization.ElozoOldal,
          morePages: Globalization.TobbOldal
        }
      },
      noRecords: true,
      messages: {
        noRecords: Globalization.NincsTalalat
      },
      height: gridHeight
    });

    var grid = KretaGridHelper.getKendoGridData(gridId);
    if (!CommonUtils.isNullOrEmpty(rowTemplateId)) {
      grid.setOptions({
        rowTemplate: window.kendo.template($('#' + rowTemplateId).html())
      });
    }

    grid.content.attr(
      'style',
      'max-height: ' + gridContentMaxHeight + 'px !important;'
    );
    grid.table.css('min-width', '100%');
  };

  kretaImportGridHelper.getFormObject = function (formName) {
    var formElement = $('#' + formName);
    if (!CommonUtils.exists(formElement)) {
      return null;
    }
    var result = formElement.toObject();
    return result;
  };

  return kretaImportGridHelper;
})();
