﻿var KirSzinkronHelper = (function () {
  var kirSzinkronHelper = function () {};

  var szinkronData = [];

  kirSzinkronHelper.gridCellClickKreta = function (
    e,
    cellData,
    isImportFromKir
  ) {
    onChooseData(e, cellData, false, isImportFromKir);
  };

  kirSzinkronHelper.gridCellClickKir = function (e, cellData, isImportFromKir) {
    onChooseData(e, cellData, true, isImportFromKir);
  };

  function onChooseData(e, cellData, isKirData, isImportFromKir) {
    var kirCellId = '#kir_ertek_' + e;
    var kretaCellId = '#kreta_ertek_' + e;

    if (isKirData) {
      if ($(kirCellId).parent().hasClass('selectedKirSzinkronData')) {
        $(kirCellId).parent().removeClass('selectedKirSzinkronData');
        $('#kivalasztottOszlopSzoveg_' + e).val('');
      } else {
        $(kirCellId).parent().addClass('selectedKirSzinkronData');
        $(kretaCellId).parent().removeClass('selectedKirSzinkronData');
        $('#kivalasztottOszlopSzoveg_' + e).val(
          isImportFromKir ? cellData.innerText : ''
        );
      }
    } else {
      if ($(kretaCellId).parent().hasClass('selectedKirSzinkronData')) {
        $(kretaCellId).parent().removeClass('selectedKirSzinkronData');
        $('#kivalasztottOszlopSzoveg_' + e).val('');
      } else {
        $(kretaCellId).parent().addClass('selectedKirSzinkronData');
        $(kirCellId).parent().removeClass('selectedKirSzinkronData');
        $('#kivalasztottOszlopSzoveg_' + e).val(
          isImportFromKir ? '' : cellData.innerText
        );
      }
    }
  }

  kirSzinkronHelper.collectSzinkronData = function (gridNameList, modifyUrl) {
    var gridNameArray = gridNameList.split(',');
    $.each(gridNameArray, function (index, value) {
      var grid = KretaGridHelper.getKendoGridData(value);
      if (!CommonUtils.isUndefined(grid)) {
        var gridData = grid.dataItems();

        for (var i = 0; i < gridData.length; i++) {
          var tartalom = $(
            '#kivalasztottOszlopSzoveg_' + gridData[i].AdatAzonositoNeve
          ).val();

          if (!CommonUtils.isUndefined(tartalom) && tartalom !== '') {
            szinkronData.push({
              key: gridData[i].AdatAzonositoNeve,
              value: tartalom
            });
          }
        }
      }
    });
    var formData = $('#KirImportModel').toObject();
    var postData = {
      FelhasznaloId: formData['FelhasznaloId'],
      ValtozasDictData: szinkronData
    };
    AjaxHelper.DoPost(
      modifyUrl,
      postData,
      saveKirDataResponseOk,
      saveKirDataResponseError
    );
  };

  function saveKirDataResponseOk() {
    KretaWindowHelper.successFeedBackWindow(KretaWindowHelper.destroyAllWindow);
    szinkronData = [];
  }

  function saveKirDataResponseError() {
    var msg = '@(CommonResource.Hiba)';
    KretaWindowHelper.feedbackWindow(
      '@(CommonResource.Hiba)',
      msg,
      true,
      KretaWindowHelper.destroyAllWindow
    );
    szinkronData = [];
  }

  return kirSzinkronHelper;
})();
