﻿var OsztalyBevitelVisibilityHelper = function () {
  var helper = function () {};

  helper.feladatellatasiHelyIsSzakkepzesesJSON = '';
  helper.feladatellatasiHelyIsNktJSON = '';
  helper.isSelectedTanev20_21OrLater = '';
  helper.isSelectedTanev21_22OrLater = '';
  helper.szakmacsoportTipusNa = null;
  helper.agazatTipusNa = null;
  helper.szakkepesitesTipusNa = null;
  helper.reszszakkepesiteTipusNa = null;
  helper.agazatTipusUjSzktNa = null;
  helper.szakmaTipusUjSzktNa = null;
  helper.szakmairanyTipusUjSzktNa = null;
  helper.tanulmanyiTeruletNktTipusNa = null;
  helper.szakkepesitesNktTipusNa = null;
  helper.szakiranyNktTipusNa = null;

  helper.SetGimnaziunTobbOsztalyosVisibility = function (selectedFeladHelyId) {
    var feladatellatasiHelyIsGimnazium = CommonUtils.JSONparse(
      $('#GimnaziumIdsJSON').val()
    );
    var isGimnazium = false;

    $.each(feladatellatasiHelyIsGimnazium, function (index, value) {
      if (value == selectedFeladHelyId) {
        isGimnazium = true;
        return false;
      }
    });

    var div = $('#Gimnazium');
    if (isGimnazium) {
      div.show();
    } else {
      div.hide();
    }
  };

  //Nevelés-oktatás  EGYMI
  helper.SetSzakkepesitesBlokkVisibilityNevOktEsEgymi = function (
    selectedFeladHelyId
  ) {
    var selectedFeladHelyIsSzakkepzeses = getSelectedFelhelyType(
      helper.feladatellatasiHelyIsSzakkepzesesJSON,
      selectedFeladHelyId
    );

    var selectedFeladHelyIsNkt = getSelectedFelhelyType(
      helper.feladatellatasiHelyIsNktJSON,
      selectedFeladHelyId
    );

    var ujSzktContainer = $('#ujSzktContainer');
    var regiSzktContainer = $('#regiSzktContainer');
    var nktContainer = $('#NktContainer');

    if (
      helper.isSelectedTanev20_21OrLater &&
      !helper.isSelectedTanev21_22OrLater
    ) {
      if (selectedFeladHelyIsSzakkepzeses) {
        regiSzktContainer.show();
        ujSzktContainer.show();
      } else {
        regiSzktContainer.hide();
        ujSzktContainer.hide();
        setRegiSzktDataToDefault();
        setUjSzktDataToDefault();
      }

      if (selectedFeladHelyIsNkt) {
        nktContainer.show();
      } else {
        nktContainer.hide();
        setNktDataToDefault();
      }
    } else {
      if (
        selectedFeladHelyIsSzakkepzeses &&
        !helper.isSelectedTanev21_22OrLater
      ) {
        regiSzktContainer.show();
      } else {
        regiSzktContainer.hide();
        setRegiSzktDataToDefault();
      }
      ujSzktContainer.hide();
      nktContainer.hide();
      setUjSzktDataToDefault();
      setNktDataToDefault();
    }

    setOsztalyKepzesiJellemzokVisibility(
      selectedFeladHelyIsNkt && helper.isSelectedTanev21_22OrLater
    );
  };

  //AMI
  helper.SetSzakkepesitesBlokkVisibilityAmi = function (selectedFeladHelyId) {
    var selectedFeladHelyIsNkt = getSelectedFelhelyType(
      helper.feladatellatasiHelyIsNktJSON,
      selectedFeladHelyId
    );

    var nktContainer = $('#NktContainer');

    if (
      selectedFeladHelyIsNkt &&
      helper.isSelectedTanev20_21OrLater &&
      !helper.isSelectedTanev21_22OrLater
    ) {
      nktContainer.show();
    } else {
      nktContainer.hide();
      setNktDataToDefault();
    }

    setOsztalyKepzesiJellemzokVisibility(
      selectedFeladHelyIsNkt && helper.isSelectedTanev21_22OrLater
    );
  };

  function getSelectedFelhelyType(felhelyJSON, selectedFeladHelyId) {
    var result = false;
    var felhelyDictionary = '';
    if (CommonUtils.isNullOrUndefined(felhelyJSON)) {
      return result;
    } else {
      felhelyDictionary = CommonUtils.JSONparse(felhelyJSON);
    }

    $.each(felhelyDictionary, function (id, value) {
      if (id === selectedFeladHelyId) {
        result = value;
        return false;
      }
    });
    return result;
  }

  function setRegiSzktDataToDefault() {
    $('#SzakmacsoportId')
      .data('kendoComboBox')
      .value(helper.szakmacsoportTipusNa);
    $('#AgazatId').data('kendoComboBox').value(helper.agazatTipusNa);
    $('#SzakkepesitesId')
      .data('kendoComboBox')
      .value(helper.szakkepesitesTipusNa);
    $('#ReszSzakkepesitesId')
      .data('kendoComboBox')
      .value(helper.reszszakkepesiteTipusNa);
  }

  function setUjSzktDataToDefault() {
    $('#AgazatUjSzktTipusId ')
      .data('kendoComboBox')
      .value(helper.agazatTipusUjSzktNa);
    $('#SzakmaTipusId ')
      .data('kendoComboBox')
      .value(helper.szakmaTipusUjSzktNa);
    $('#SzakmairanyTipusId ')
      .data('kendoComboBox')
      .value(helper.szakmairanyTipusUjSzktNa);
  }

  function setNktDataToDefault() {
    $('#TanulmanyiTeruletNktTipusId ')
      .data('kendoComboBox')
      .value(helper.tanulmanyiTeruletNktTipusNa);
    $('#SzakkepesitesNktTipusId ')
      .data('kendoComboBox')
      .value(helper.szakkepesitesNktTipusNa);
    $('#SzakiranyNktTipusId ')
      .data('kendoComboBox')
      .value(helper.szakiranyNktTipusNa);
  }

  function setOsztalyKepzesiJellemzokVisibility(isVisible) {
    var kepzesijellemzoTabstripItem = $('#OsztalyKepzesiJellemzok_TabStripId');
    if (!CommonUtils.isNullOrUndefined(kepzesijellemzoTabstripItem)) {
      if (isVisible) {
        $('#OsztalyKepzesiJellemzok_TabStripId').attr(
          'style',
          'display:block !important'
        );
      } else {
        $('#OsztalyKepzesiJellemzok_TabStripId').attr(
          'style',
          'display:none !important'
        );
      }
    }
  }

  return helper;
};
